]> arthur.barton.de Git - bup.git/blobdiff - Makefile
Makefile: check $(shell) exit statuses
[bup.git] / Makefile
index 11896134586681951ea2ea55de7c40033d4bd256..5ffa48037f87bbc32817ae800d8aad44a5edd140 100644 (file)
--- a/Makefile
+++ b/Makefile
@@ -1,13 +1,30 @@
 
-sampledata_rev := $(shell t/configure-sampledata --revision)
+SHELL := bash
+pf := set -o pipefail
+
+define isok
+  && echo " ok" || echo " no"
+endef
+
+# If ok, strip trailing " ok" and return the output, otherwise, error
+define shout
+$(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
+endef
+
+sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
+sampledata_rev := \
+  $(call shout,$(sampledata_rev),Could not parse sampledata revision)
+
 current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)
 
-OS:=$(shell uname | sed 's/[-_].*//')
+os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
+os := $(call shout,$(os),Unable to determine OS)
+
 CFLAGS := -Wall -O2 -Werror -Wno-unknown-pragmas $(PYINCLUDE) $(CFLAGS)
 CFLAGS := -D_FILE_OFFSET_BITS=64 $(CFLAGS)
 SOEXT:=.so
 
-ifeq ($(OS),CYGWIN)
+ifeq ($(os),CYGWIN)
   SOEXT:=.dll
 endif
 
@@ -17,7 +34,9 @@ else
   test_tmp := $(CURDIR)/t/tmp
 endif
 
-initial_setup := $(shell ./configure-version --update)
+initial_setup := $(shell ./configure-version --update $(isok))
+initial_setup := $(call shout,$(initial_setup),Version configuration failed))
+
 bup_deps := bup lib/bup/_version.py lib/bup/_helpers$(SOEXT) cmds
 
 all: $(bup_deps) Documentation/all $(current_sampledata)
@@ -30,8 +49,16 @@ Documentation/all: $(bup_deps)
 $(current_sampledata):
        t/configure-sampledata --setup
 
+# This needs to be a delayed assignment
+PYTHON = $(shell cmd/bup-python -c 'import sys; print sys.executable')
+
+define install-python-bin
+  set -e; \
+  sed -e '1 s|.*|#!$(PYTHON)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
+  chmod 0755 $2;
+endef
+
 INSTALL=install
-PYTHON=python
 PREFIX=/usr
 MANDIR=$(DESTDIR)$(PREFIX)/share/man
 DOCDIR=$(DESTDIR)$(PREFIX)/share/doc/bup
@@ -49,10 +76,11 @@ install: all
          $(INSTALL) -m 0644 \
                Documentation/*.html \
                $(DOCDIR)
-       $(INSTALL) -pm 0755 bup $(BINDIR)
-       $(INSTALL) -pm 0755 \
-               cmd/bup-* \
-               $(LIBDIR)/cmd
+       $(call install-python-bin,bup,"$(BINDIR)/bup")
+       set -e; \
+       for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
+         $(call install-python-bin,"$$cmd","$(LIBDIR)/$$cmd") \
+       done
        $(INSTALL) -pm 0644 \
                lib/bup/*.py \
                $(LIBDIR)/bup
@@ -94,9 +122,13 @@ t/tmp:
 runtests: runtests-python runtests-cmdline
 
 runtests-python: all t/tmp
-       TMPDIR="$(test_tmp)" $(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py
+       $(pf); TMPDIR="$(test_tmp)" \
+         $(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
+           | tee -a t/tmp/test-log/$$$$.log
 
 cmdline_tests := \
+  t/test-index.sh \
+  t/test-split-join.sh \
   t/test-fuse.sh \
   t/test-drecurse.sh \
   t/test-cat-file.sh \
@@ -105,6 +137,7 @@ cmdline_tests := \
   t/test-index-clear.sh \
   t/test-index-check-device.sh \
   t/test-ls.sh \
+  t/test-tz.sh \
   t/test-meta.sh \
   t/test-on.sh \
   t/test-restore-map-owner.sh \
@@ -122,19 +155,27 @@ cmdline_tests := \
   t/test.sh
 
 # For parallel runs.
-tmp-target-run-test-%: all t/tmp
-       TMPDIR="$(test_tmp)" t/test-$*
+tmp-target-run-test%: all t/tmp
+       $(pf); TMPDIR="$(test_tmp)" \
+         t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
 
-runtests-cmdline: $(subst t/test-,tmp-target-run-test-,$(cmdline_tests))
+runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))
 
 stupid:
        PATH=/bin:/usr/bin $(MAKE) test
 
 test: all
-       ./wvtestrun $(MAKE) PYTHON=$(PYTHON) runtests-python runtests-cmdline
+       if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
+       mkdir -p t/tmp/test-log
+       ./wvtest watch --no-counts \
+         $(MAKE) PYTHON=$(PYTHON) runtests-python runtests-cmdline
+       ./wvtest report t/tmp/test-log/*.log
 
 check: test
 
+cmd/python-cmd.sh: config/configure config/configure.inc
+       ./configure
+
 cmds: \
     $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
     $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))
@@ -152,6 +193,7 @@ cmd/bup-%: cmd/%-cmd.sh
 export-docs: Documentation/all
        git update-ref refs/heads/man origin/man '' 2>/dev/null || true
        git update-ref refs/heads/html origin/html '' 2>/dev/null || true
+       set -eo pipefail; \
        GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
        rm -f $${GIT_INDEX_FILE} && \
        git add -f Documentation/*.1 && \
@@ -173,14 +215,15 @@ push-docs: export-docs
 # import pregenerated doc files from origin/man and origin/html, in case you
 # don't have pandoc but still want to be able to install the docs.
 import-docs: Documentation/clean
-       git archive origin/html | (cd Documentation; tar -xvf -)
-       git archive origin/man | (cd Documentation; tar -xvf -)
+       $(pf); git archive origin/html | (cd Documentation && tar -xvf -)
+       $(pf); git archive origin/man | (cd Documentation && tar -xvf -)
 
 clean: Documentation/clean config/clean
        rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
                .*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
                *.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
                bup bup-* cmd/bup-* \
+               cmd/python-cmd.sh \
                randomgen memtest \
                testfs.img lib/bup/t/testfs.img
        if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi